﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.StartScreen;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SecondaryTilesDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {

        public const string dynamicTileId = "SecondaryTile.LiveTile";

        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private async void xCreate_Click_1(object sender, RoutedEventArgs e)
        {
            Uri logo = new Uri("ms-appx:///Assets/squareTile-sdk.png");
            Uri wideLogo = new Uri("ms-appx:///Assets/tile-sdk.png");

            // During creation of secondary tile, an application may set additional arguments on the tile that will be passed in during activation.
            // These arguments should be meaningful to the application. In this sample, we'll pass in the date and time the secondary tile was pinned.
            string tileActivationArguments = dynamicTileId + 
                " WasPinnedAt=" + DateTime.Now.ToLocalTime().ToString();


            // Create a Secondary tile
            SecondaryTile secondaryTile = 
                new SecondaryTile(dynamicTileId,
                        "A Live Secondary Tile (JL)",
                        "Secondary Tile Sample Live Secondary Tile(JL)",
                        tileActivationArguments,
                        TileOptions.ShowNameOnLogo | TileOptions.ShowNameOnWideLogo,
                        logo,
                        wideLogo);

            // Specify a foreground text value.
            // The tile background color is inherited from the parent unless a separate value is specified.
            secondaryTile.ForegroundText = ForegroundText.Light;

            // OK, the tile is created and we can now attempt to pin the tile.
            // Note that the status message is updated when the async operation to pin the tile completes.
            bool isPinned = 
                await secondaryTile.RequestCreateForSelectionAsync(
                    GetElementRect((FrameworkElement)sender), Windows.UI.Popups.Placement.Below);

            if (isPinned)
            {
                xMessage.Text = "Secondary tile successfully pinned.";
            }
            else
            {
                xMessage.Text = "Secondary tile not pinned.";
            }

        }
        public static Rect GetElementRect(FrameworkElement element)
        {
            GeneralTransform buttonTransform = element.TransformToVisual(null);
            Point point = buttonTransform.TransformPoint(new Point());
            return new Rect(point, new Size(element.ActualWidth, element.ActualHeight));
        }

    }
}
